#!/usr/bin/perl

# edit.cgi
#
# display and edit an image db entry


use HTTP::Date;

$q = new CGI, unless $q;

db_connect();

$User = Userverify($q);

chdir "$RealDir/scripts/";
$tmpdir = "$RealDir/scripts/tmp/";


$Imageid = $q->param('id');
$Action = $q->param('action');
$Next = $q->param('next');
$Terms = $q->param('srch');
$NewAlbum = $q->param('albuminsert');
$Transform = $q->param('transform');
$Ref = $q->param('ref');
$Dowhat = $q->param('dowhat');
$NewFile = $q->param('newfile');
$Unlock = $q->param('unlock');
$RefAlbum = $q->param('refalbum');

$Referer = $ENV{'HTTP_REFERER'};

$nf = "";
$Next = "";
$NextEdit = "";
$Terms = "";
$NextSearch = "";

if ($ARGV[0] !~ /^$/) {
	$Imageid = $ARGV[0];
}
if ($ARGV[1] =~ /^[0-9]+$/) {
	$nf = $ARGV[1];
	$Next = $nf;
	$NextEdit = "<input type=hidden name=next value=$nf>\n";
}
if ($ARGV[2] !~ /^$/) {
	$Terms = $ARGV[2];
	$NextSearch = "<input type=hidden name=srch value=$Terms>\n";
}


if (db_connect() == -1) {
	print "Error connecting to database\n";
	exit(0);
}

$owner = db_image_owner($Imageid);

# make sure the currently logged in user owns the image

if ($owner !~ /^$User$/) {
	print "Location: login\n\n";
	exit(0);
}

$File = db_id_to_file($Imageid);
if ($File == -1) {
	print "\n\nImage id $Imageid not in db!\n";
}

if (!db_image_exists($Imageid)) {
	print "\n\nError $file does not exist in db!\n";
	exit(0);
}

# delete the image cache entry
tie %db, 'DB_File', "../cache/image" or warn "Can't init image cache: $!";
delete($db{$Imageid});
untie %db;

if ($Dowhat =~ /Delete/) {
	if ($RefAlbum > 0) {
		AlbumDelPix($RefAlbum, $Imageid);
	}
# fix fix fix fix fix fix fix 
	print "Location: $Referer\n\n";
	exit(0);
} elsif ($Unlock) {
	$Db_Conn->do("UPDATE photos SET pub = 't' WHERE imageid = $Imageid AND owner = '$User'");
	print "Location: " . ForceUrl($Referer) . "\n\n";
	exit(0);
} elsif ($Action !~ "change") {
	GetInfo($Imageid);

PrintHeader($User, "Editing $File", "", "Editing $File");

#$imgfil = $URI . db_get_image_file($Imageid,1);
$imgfil = $Repos_Url . db_get_image_file($Imageid,1);

if ($RefAlbum > 0) {
	$albumshow = AlbumShowAncestor($RefAlbum, "", 1, 1);
} else {
	$albumshow = "";
}

print <<EOF;
<title>PhotoShelf: Editing $File</title>
<form action=$URI/index.cgi/edit.cgi method=post enctype="multipart/form-data">
<input type=hidden name=id value=$Imageid>
<input type=hidden name=action value=change>
$NextEdit
$NextSearch
<table border=0>
<tr><td >
EOF

ImgBorder($imgfil, $smallwidth, $smallheight);

#<img src=$imgfil alt="$caption" width=$smallwidth height=$smallheight>
print "<center><input type=text name=comment value=\"$comment\" size=60></center>";
print "</td>";

ShowTables();

} elsif ($Transform !~ /^$/) {
	if ($Transform =~ /Right 90/) {
		image_rotate($Imageid, 90);
	} elsif ($Transform =~ /180/) {
		image_rotate($Imageid, 180);
	} elsif ($Transform =~ /Left 90/) {
		image_rotate($Imageid, 270);
	}
	print "Expires: Wed, 1 Jan 1970 00:00:00 GMT\n";
	print "Location: $Ref\n\n";
	exit(0);
} else {
	EditFile($Imageid);
}

sub GetInfo {
my($id) = @_;
my($res,$qry);

	$qry = sprintf("SELECT * FROM photos WHERE imageid = %d", $id);
	($imgid,$filename,$filesize,$width,$height,$directory,$format,$origin,$cameramake,
	$cameramodel,$createdate,$insertdate,$subtype,$status,$copyright,
	$lighting,$filmiso,$filmexposure,$filmaperture,$filmmetering,$filmfoclen,
	$flash,$quality,$whitebal,$expmode,$country,$city,$keywords,
	$comment,$caption,$owner,$thumbsize,$smallwidth,$smallheight,$tw,$th,$pub,
	$createtm,$inserttm) = $Db_Conn->selectrow_array($qry);
}

sub ShowTables {

	if ($RefAlbum > 0) {
		$RefBit = "<input type=hidden name=refalbum value=$RefAlbum>";
	} else {
		$RefBit = "";
	}
	($pub) = $Db_Conn->selectrow_array("SELECT pub FROM photos WHERE imageid = $Imageid");
	$pubstr = ($pub ? "checked" : "");
	$NonEditTable = "<td valign=top>$albumshow<table border=0><tr><th colspan=2>$file</th></tr>";
	$EditTable = "<table border=1 align=top bgcolor=$TableHighBG><tr><th colspan=4>Technical info</th></tr>\n";
	$EditSubTable = "";
	MakeTables();
	print $NonEditTable;
	print <<EOF;
<form method=post enctype="multipart/form-data">
<input type=hidden name=ref value="$Referer">
$RefBit
<input type=submit name=transform value="Rotate Left 90">&nbsp;<input type=submit name=transform value="Rotate Right 90">
<center><input type=submit name=transform value="Rotate 180"></center>
<hr>
Replace image with:<br>
<input type=file name=newfile>
<hr>
<input type=checkbox name=pub value=1 $pubstr> Publicly viewable?
<hr>
EOF
	print <<EOF;

</td></tr><tr>
<input type=hidden name=ref value="$Referer">
<td  colspan=2 align=left><table><tr><td>
EOF
	print "\n\n$EditTable</td><td>";
	print "<table border=1 bgcolor=$TableHighBG><tr><th colspan=4>Subject information</th></tr><tr>$EditSubTable</table></td></tr>";
	print "<tr><td colspan=2 align=right>";
	print "</td></tr></table>\n";
	$NonEditTable = "";
	$EditTable = "";
	$EditSubTable = "";
}

sub MakeTables {
my($n) = 0;
my($desc);

	foreach $field (0..$#DisplayedInfo) {
		$dbvar = $DisplayedInfo[$field][0];
		$descr = $DisplayedInfo[$field][1];
		$convert = $DisplayedInfo[$field][2];
		$editable = $DisplayedInfo[$field][3];
		$string = $DisplayedInfo[$field][4];
		$subjinfo = $DisplayedInfo[$field][5];
		$vartype = $DisplayedInfo[$field][6];
		$desc = ${$dbvar};
		$desc =~ s/__APOSTROPHE__/\'/g, if ($vartype == 0);
		next, if ($dbvar eq "comment");
		if ($editable) {
			if ($subjinfo) {
				$tab = "EditSubTable";
			} else {
				$tab = "EditTable";
			}
		} else {
			$tab = "NonEditTable";
		}
		$val =~ s/__APOSTROPHE__/\'/g, if ($vartype == 0);
		
		if ($convert) {
			$desc = 0, if ($desc eq "");
			($undef, $desc) = db_id_to_nd($dbvar, $desc);
		}
		${$tab} .= "\n\n<td class=imgeditvar bgcolor=$TableLowBG><font size=-1 color=$TextLoTable>$descr</td>\n";
		if ($editable) {
			my($len) = length($desc);
			$len = 10, unless $len > 5;
			$len = 25, unless $len < 21;
			if ($convert) {
				${$tab} .= "<td style=imgeditval bgcolor=$TableHighBG><select name=$dbvar><option>\n";
				@vars = list_types($dbvar);
				foreach $var (@vars) {
					($id,$nam,$des) = split(/:/, $var);
					$sel = ($desc eq $des ? "selected" : "");
					${$tab} .= "<option value=$id $sel>$nam\n";
				}
				${$tab} .= "</select></td>\n";
			} else {
				${$tab} .= "<td style=imgeditval bgcolor=$TableHighBG><font size=-1 color=$TextLoTable>";
				if ($vartype == 0 || $vartype == 2) {
					$desc = time2str(${$dbvar}), if ($vartype == 2);
					$len = length($desc);
					$len = 10, unless ($len > 5);
					$len = 20, unless ($len < 14);
					${$tab} .= "<input type=text name=$dbvar value=\"$desc\" size=$len>\n";
				} elsif ($vartype == 1) {
					$checked = ($desc == 1 ? "checked" : "");
					${$tab} .= "<input type=checkbox name=$dbvar value=\"$desc\" $checked";
				}

				${$tab} .= "</td>\n";
			}
			$n{$tab}++;
			${$tab} .= "</tr><tr>\n", if ($n{$tab} % 2 == 0);
		} else {
			if ($vartype == 0 || $vartype == 2) {
				$desc = time2str($desc), if ($vartype == 2);
			}
			${$tab} .= "<td bgcolor=$TableHighBG style=imgeditval><font size=-1 color=$TextTable>&nbsp;$desc</td></tr>\n";
		}
	}
	$EditTable .= "</table>";
	$EditSubTable .= <<EOF;
<tr><td align=left><input type=submit value=\"Delete Image\" name=dowhat></td>
<td colspan=3 align=center style=imgeditval>
Add to album:
<select name=albuminsert>
<option selected>
EOF
	@Albums = AlbumList("", -1);
	foreach $alb ( sort @Albums) {
		($owner, $album,$id) =split(/:/, $alb);
		$EditSubTable .=  "<option value=$id>$album\n", if ($owner eq $User);
	}
	$EditSubTable .= <<EOF;
</select>
<input type=submit value=\"Apply Changes\" name=dowhat></td>
</tr></table>
EOF
#$imgfil = $URI . db_get_image_file($Imageid,0);
$imgfil = $Repos_Url . db_get_image_file($Imageid,0);

	$NonEditTable .= "<tr><td colspan=2 align=center><img src=$imgfil width=$tw height=$th><br>Thumbnail</td></tr>";

	$NonEditTable .= "<tr><td align=right colspan=2><a href=search.cgi?edone=$Next&terms=$Terms>Edit next</a></td></tr>", if ($Terms !~ /^$/);
	if ($RefAlbum > 0) {
		my($prev,$next) = AlbumNext($RefAlbum, $Imageid);
		if ($prev > 0) {
			$NonEditTable .= "<tr><td align=left><a href=edit.cgi?id=$prev&refalbum=$RefAlbum>&lt;Edit Prev</a></td>";
		} else {
			$NonEditTable .= "<tr><td align=left>&nbsp;</td>";
		}
		if ($next > 0) {
			$NonEditTable .= "<td align=right><a href=edit.cgi?id=$next&refalbum=$RefAlbum>Edit Next&gt;</a></td></tr>";
		} else {
			$NonEditTable .= "<tr><td align=right>&nbsp;</td></tr>";
		}
	}
	$NonEditTable .= "</td></tr></table>";
}

sub EditFile {
my ($id) = @_;

	if ($NewFile !~ /^$/) {
		ReplaceImage();
	}
	if ($NewAlbum !~ /^$/) {
		exit(1), if ($NewAlbum !~ /^[0-9]+$/);
		$res = AlbumAdd($NewAlbum, $id);
		if (!$res) {
			print "Error adding to album!<p>\n";
		}
	}
	$ChStr = "UPDATE photos SET ";
	$pub = $q->param('pub');
	if ($pub == 1) {
		$ChStr .= "pub = 't', ";
	} else {
		$ChStr .= "pub = 'f', ";
	}
	foreach $field (0..$#DisplayedInfo) {
		$dbvar = $DisplayedInfo[$field][0];
		$descr = $DisplayedInfo[$field][1];
		$convert = $DisplayedInfo[$field][2];
		$editable = $DisplayedInfo[$field][3];
		$string = $DisplayedInfo[$field][4];
		$vartype = $DisplayedInfo[$field][6];
		$val = $q->param($dbvar);
		next, if ($val =~ /^$/);
		$val = str2time($val), if ($vartype == 2);
		$val =~ s/\'/__APOSTROPHE__/g, if ($vartype == 0);
		if ($string) {
			$ChStr .= "$dbvar = '$val' ";
		} else {
			$ChStr .= "$dbvar = $val ";
		}
		$ChStr .= " , ";
	}
	$ChStr .= " imageid = $id WHERE imageid = $id";
	$Db_Conn->do($ChStr);
	if ($Terms !~ /^$/) {
		$str = $q->url_encode($Terms);
		print "Location: search.cgi?edone=$Next&terms=$str\n\n";
	} else {
		my $new = time();
		$Referer .= "&refalbum=$NewAlbum", if ($NewAlbum > 0 && $Referer =~ /edit/);
		print "Location: " . ForceUrl("$Referer") . "\n\n";
		exit(0);
	}
}

sub Delete_Warn {
my ($msg) = @_;

	print "Warning: <b>$msg</b><p>\n";
}

sub Delete_Fail {
my ($msg) = @_;

	print "Error deleting $file: $msg<p>\n";
}

sub ReplaceImage {
my($mime,$bytesread,$buffer,$newfile,$size,$qry,$res);

	if ($NewFile =~ /^$/) {
		warn "Empty filename!";
		return 1;
	}
	$mime = $q->uploadInfo($NewFile)->{'Content-Type'};
	if ($mime !~ /^image\//) {
		warn "Incorrect mime type!";
		return (1);
	}
	if (!db_image_exists($Imageid)) {
		print "Location: $Referer\n\n";
		warn "Erk image $Imageid doesnt exist";
		exit(0);
	}
# replace main image
	$newfile = "$tmpdir" . "/" . $$ . ".img";
	open (OUTFILE,">$newfile") or die "Can't open $newfile: $!";
	while ($bytesread=read($NewFile,$buffer,1024)) {
		print OUTFILE $buffer;
	}
	close OUTFILE;

	$dir = repository_insert($newfile, $Imageid, 1);
	if ($dir == -1) {
		warn "Error replacing image $Imageid";
		exit(0);
	}

# update database image size/etc
	$size = (stat($newfile))[7];
	$Db_Conn->do("UPDATE photos SET filesize = $size WHERE imageid = $Imageid");
	unlink $newfile;
}
