#!/usr/bin/perl

chdir "$RealDir/scripts/" || die "Check \$RealDir ($RealDir): $!";


use PhotoShelf;


db_connect();

$User = Userverify($q, -1);

print "Content-type: text/html\n\n";

MakeTopPhotos();
($NumImages) = $Db_Conn->selectrow_array("SELECT count(imageid) FROM photos");

if ($User !~ /^nobody$/) {
	$loggedin = "</center><small>Logged in as: <b>$User</b></small><center>";
	$top = AlbumTop($User);
	$alblist = "?level=$top";
} else {
	$loggedin = "";
	$alblist = "";
}

%TopButtons = (
		"Login" => "login",
		"Search" => "search",
		"My Albums" => "albumlist$alblist",
		"Public Albums" => "publiclist",
		"Add Image" => "addimage",
		"Logout" => "logout",
);

print <<EOF;
<title>PhotoShelf: Top</title>
<body bgcolor=$BGNorm face="Helvetica,Arial,sans-serif" text=$TextNorm link=$LinkText vlink=$VLinkText>
<table width=100% border=0>
	<tr bgcolor=$TableLowBG><th align=left><font color=$TextLoTable>PhotoShelf - PhotoArchiver</th><th align=right>
<font color=$TextLoTable>
$NumImages Photos in archive!
	</th></tr>
	<tr>
	<td align=left valign=top>
		<table align=center border=0 cellpadding=4 cellspacing=5>
		<tr bgcolor=$TabsBG>
		$loggedin
EOF
		foreach $button (keys % TopButtons) {
			$buttonurl = $TopButtons{$button};
			print "<th><font color=$TabsFG><a href=\"$buttonurl\">$button</a></th>\n";
		}
	print <<EOF;
		</tr>
		</table><br>
	<table border=0 valign=top bgcolor=$TableHighBG>
	<tr bgcolor=$TableLowBG><th ><font color=$TextLoTable>Welcome to PhotoShelf!</th></tr>
	<tr><td><font color=$TextTable>
	Welcome to PhotoShelf, an archiver and management system for
	all digital images. More info available soon.
	</td></tr></table>
	</td><td>
EOF
print QuickSearch();
print <<EOF;
	</td>
	</tr>
	<tr>
	<td>


	<p>
	<table border=0 bgcolor=$TableHighBG>
	<tr bgcolor=$TableLowBG><th><font color=$TextLoTable>Date</th><th><font color=$TextLoTable>News</th></tr>
EOF
	open (NEWS, "news.txt");
	while (<NEWS>) {
		chomp;
		($date, $news) = split(/:/);
		print "<tr><td><font color=$TextTable>$date</td>";
		print "<td><font color=$TextTable>$news</td>";
	}
	close NEWS;

print <<EOF;
	</table>
	</td>
	<td align=right valign=top>
		<table align=center bgcolor=$TableHighBG cellspacing=2>
			<tr><th align=center colspan=3 bgcolor=$TableLowBG><font color=$TextLoTable>Random New Photos</th></tr>
				$TopPhotos
		</table>
	</td>
	</tr>
</table>
		<hr><pre>
EOF

foreach $arg (keys % ENV) {
#	print "$arg = " . $ENV{$arg} . "\n";
}

sub MakeTopPhotos {
my(@Top) = ();

#	open(TOP, "top_photos") or warn "Cant open top photos: $!";
	@Top = db_newest_images(6);
	$TopPhotos = "<tr>";
	for ($n = 0 ; $n < 6 ; $n++ ) {
		$top = pop(@Top);
		$TopPhotos .= ShowImage($top, 1);
		$TopPhotos .= "</tr><tr>", if ($n == 2);
	}
	$TopPhotos .= "</tr>";
}

#exit(0);
