#!/usr/bin/perl

use PhotoShelf;

sub Usage {
	print "Usage: $0 [-v] <fileid>\n\n";
	print "\t-v\tVerbose mode.\n";
	exit(0);
}

if ($#ARGV < 0) {
	Usage();
}

while ($arg = shift @ARGV) {
	if ($arg =~ /^-v$/) {
		$verbose = 1;
	} else {
		push (@Files, $arg);
	}
}

$Owner = $ENV{USER};

db_connect();

foreach $File (@Files) {

	if (!db_image_exists($File)) {
		die "Image $File does not exist in database!";
	}

	($count) = $Db_Conn->do("SELECT albumrefcount FROM photos WHERE imageid = $File");
	if ($count > 0) {
		warn "Cannot delete $File - still has album references";
	} else {
		db_del_pic($id);
	}
}

